"use strict";
/**
 * @private
 * Map of possible pages that can be navigated to using an Ionic NavController
 */
var NavRegistry = (function () {
    function NavRegistry(pages) {
        if (pages === void 0) { pages = []; }
        var pagePairs = pages.map(function (page) { return [page['name'], page]; });
        this._pages = new Map();
        for (var i = 0; i < pagePairs.length; i++) {
            var pair = pagePairs[i];
            this._pages.set(pair[0], pair[1]);
        }
    }
    NavRegistry.prototype.get = function (pageName) {
        return this._pages.get(pageName);
    };
    NavRegistry.prototype.set = function (page) {
        this._pages.set(page.name, page);
    };
    return NavRegistry;
}());
exports.NavRegistry = NavRegistry;
